# SHOTP

SHOTP is a simple command line OTP tool that can read data from ini
files, is scriptable and has an optional simple interactive interface.

## Synopsys

```
shotp: usage: shotp OPTIONS [<key> [..]]
  Where options can be:
    -0 <seconds>   .. specify T0 (RFC 6238, section 4.1)
    -c             .. continuous mode
    -d             .. print debug messages
    -e <encoding   .. specify or override encoding (default is base32)
    -i             .. interactive mode (useful for -I and -Y)
    -l <length>    .. output length amount of digits
    -t <time>      .. use specified unix seconds time instead of current time
    -v             .. ouput value only, instead of extra info
    -x <seconds>   .. specify X (RFC 6238, section 4.1)
    -V             .. print version and exit
  Exactly one of those input file options must be used:
    -X <txt-file>  .. read secret from text file
    -I <ini-file>  .. read input from ini file
  Keys must not be specified if -X is specified.
  Interactive or continuous mode must not be used if -X is specified.
  Help:
    -h            .. show this help
```

## Importing Data

An example script to create ini style files from
[FreeOTP+](https://github.com/helloworld1/FreeOTPPlus) shared json
files is included with the name `ini_of_freeotpplus_json.sh`.

## Example Configurations

### INI File

``` ini
[server1]
    digits = 6
    totp_x = 30
    totp_t0 = 0
    encoding = hex
    secret = ffffffffffffffffffffffffffffffffffffffff

[server2]
    digits = 6
    totp_x = 30
    totp_t0 = 0
    encoding = base32
    secret = KNXW 2ZKF PBQW 24DM MVJW ky3s MV2F G5DS
	
[server2_copy]
    encoding = base32
    secret = KNXW 2ZKF PBQW 24DM MVJW ky3s MV2F G5DS
```

Note: `server2_copy` is the same as `server2`, since all other settings in `server2` are
defaults.

## Limitations

### Writing is not supported

SHOTP will only read your text or ini files. Create, add entries and
modify them with any other tools of choice.

### YAML

Code to read yaml files exists, but currently bash-yaml does not
provide the required functions to support enumeration in an easy way.
